package space.kklochko.jpa_hospital_example.db.repositories;

import jakarta.persistence.EntityManager;
import jakarta.persistence.TypedQuery;
import space.kklochko.jpa_hospital_example.db.repositories.blocks.TransactionalInsert;
import space.kklochko.jpa_hospital_example.db.repositories.blocks.TransactionalRemove;
import space.kklochko.jpa_hospital_example.db.repositories.blocks.TransactionalUpdate;
import space.kklochko.jpa_hospital_example.models.Indicator;

import java.util.List;
import java.util.UUID;

public class IndicatorRepository extends AbstractRepository<Indicator> {
    public IndicatorRepository(EntityManager manager){
        super(manager);
    }

    public boolean create(Indicator object) {
        TransactionalInsert insert = new TransactionalInsert();

        return insert.run(manager, object);
    }

    public Indicator read(UUID id) {
        return manager.find(Indicator.class, id);
    }

    public List<Indicator> readAll() {
        TypedQuery<Indicator> query = manager.createQuery("SELECT i FROM Indicator i", Indicator.class);

        return query.getResultList();
    }

    public boolean update(Indicator object) {
        TransactionalUpdate update = new TransactionalUpdate();

        return update.run(manager, object);
    }

    public boolean delete(UUID id) {
        Indicator object = read(id);

        TransactionalRemove remove = new TransactionalRemove();

        return remove.run(manager, object);
    }
}
