package space.kklochko.jpa_hospital_example.models;

import jakarta.persistence.*;
import lombok.AllArgsConstructor;
import lombok.Data;

import java.util.List;
import java.util.UUID;

@Table(name="departments")
@Entity
@AllArgsConstructor
@Data
public class Department {
    @Id
    @Column(nullable = true)
    UUID id;
    String name;
    String location;
    String phone;

    @OneToMany(cascade = CascadeType.ALL, mappedBy="department")
    private List<Patient> patients;

    public Department(){
        setId(UUID.randomUUID());
        setName("");
        setLocation("");
        setPhone("");
    }

    public Department(String name, String location, String phone){
        setId(UUID.randomUUID());
        setName(name);
        setLocation(location);
        setPhone(phone);
    }

    public Department(UUID id, String name, String location, String phone){
        setId(id);
        setName(name);
        setLocation(location);
        setPhone(phone);
    }
}

